/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Inicio del proceso de generacin del xml y procesamiento de ste
para la generacin/actualizacin del UML.
- ENGLISH -
Starting procedure of the xml generation process and the xml
processing for generation/update of UML.
*****************/

/* Se supone que si se habilita RUN-PARAMS, en lugar de pedir
las decisiones al usuario, las mismas ya vienen dadas por el
contenido del parmetro. Permite la generacin en "modo
silencioso". */
{com/nomadesoft/config.i}
&IF {&RUN-PARAMS} &THEN
DEFINE INPUT  PARAMETER ipchParams AS CHARACTER   NO-UNDO.
&ENDIF
DEFINE VARIABLE lhnSP AS HANDLE      NO-UNDO.

RUN com/nomadesoft/dbconnect.p PERSISTEN SET lhnSP.
IF NOT VALID-HANDLE(lhnSP) THEN
  MESSAGE "No se puede iniciar el procedimiento con las rutinas de conexin a las bases de datos" VIEW-AS ALERT-BOX.
ELSE
  session:ADD-SUPER-PROCEDURE(lhnSP).

/* *********************************  Main Block  *************************** */
DEFINE VARIABLE llgGenerar AS LOGICAL  INITIAL FALSE NO-UNDO.

&IF {&RUN-PARAMS} &THEN
llgGenerar = LOOKUP('genxml',ipchParams) NE 0.
&ELSE
UPDATE llgGenerar LABEL 'Generar XML' WITH FRAME a .
&ENDIF
IF llgGenerar THEN DO: /* generacin de archivos XML */
  &IF {&RUN-PARAMS} &THEN
  llgGenerar = LOOKUP('genddxml',ipchParams) NE 0.
  &ELSE
  llgGenerar = FALSE.
  UPDATE llgGenerar LABEL 'Generar XML Modelo de datos' WITH FRAME c.
  &ENDIF
  IF llgGenerar THEN DO: /* XML de la/las bases de datos a utilizar en el modelo */
    RUN connectDB('DictSource','sports2000','chonik',2561).
    RUN com/nomadesoft/xml/builddict.p.
  END.
  &IF {&RUN-PARAMS} &THEN
  llgGenerar = LOOKUP('genxrefxml',ipchParams) NE 0.
  &ELSE
  llgGenerar = FALSE.
  UPDATE llgGenerar LABEL 'Generar XML de XRef' WITH FRAME d.
  &ENDIF
  IF llgGenerar THEN DO: /* XML de la informacin de XREF */
    RUN connectDB('xrefsrc','claves','chonik',2563). /* informacin XREF */
    RUN connectDB('mapsissrc','claves','chonik',18860). /* informacin de estructura de menes */
    RUN com/nomadesoft/xml/buildxref.p.
  END.
END.

&IF {&RUN-PARAMS} &THEN
llgGenerar = LOOKUP('runxml',ipchParams) NE 0.
&ELSE
llgGenerar = NO.
UPDATE llgGenerar LABEL 'Procesar XML' WITH FRAME b.
&ENDIF
IF llgGenerar THEN DO: /* Procesar el XML para generar el UML */
  RUN connectDB('Repository','eaoedb','chonik',2564). /* repositorio UML */
  run com/nomadesoft/ABLaUML/startup.p.
END.
