/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Utilizando los registros de la base de datos generada a partir de la salida
de compilar los programas con xref, se crea el xml utilizado para generar
el modelado UML.
- ENGLISH -
Generation of xml used for UML building, based on XREF information.
*****************/

ROUTINE-LEVEL ON ERROR UNDO, THROW.
USING com.nomadesoft.xml.*.
USING com.nomadesoft.lib.XMLwriter.

DEFINE VARIABLE lobWrite AS CLASS XMLwriter NO-UNDO.
DEFINE VARIABLE llgBonito AS LOGICAL LABEL 'Dar formato legible al xml'  NO-UNDO.
DEFINE VARIABLE mchPaths AS CHARACTER FORMAT "x(160)" VIEW-AS FILL-IN SIZE-CHARS 40 BY 4 LABEL 'Rutas' NO-UNDO.
DEFINE FRAME a WITH 1 COLUMNS.
DEFINE FRAME b WITH 1 COLUMNS.
DEFINE FRAME c WITH 1 COLUMNS.
DEFINE FRAME d WITH 1 COLUMNS.


UPDATE llgBonito. /* dar formato al xml o generarlo tipo chorizo */

DEFINE VARIABLE lchArchivo AS CHARACTER  FORMAT "x(160)" VIEW-AS FILL-IN SIZE-CHARS 40 BY 4 LABEL 'Destino' NO-UNDO.
DEFINE VARIABLE lchFiltro AS CHARACTER FORMAT "x(40)" INITIAL 'gesexp' LABEL 'Mdulo'  NO-UNDO.
DISPLAY 'Generacin XML unidades funcionales' WITH FRAME a.
DISPLAY '(destino vacio para saltear)' WITH FRAME a.
UPDATE lchArchivo lchFiltro WITH FRAME a.
IF lchArchivo NE ? AND lchArchivo NE '' AND lchFiltro NE ? THEN DO ON ERROR UNDO, THROW:
  /* verificar la conexin a la base de datos, si no hay conexin no hay nada que hacer */
  RUN connectDB("xrefsrc",'claves','chonik',2563).
  IF NOT CONNECTED('xrefsrc') THEN
    RETURN.
  lobWrite = NEW XRefwriter().
  lobWrite:clgFormatOutput = llgBonito.
  IF lchFiltro NE ? AND lchFiltro NE '' THEN
    CAST(lobWrite,XRefwriter):writeXML(lchFiltro,lchArchivo).
  ELSE
    lobWrite:writeXML(lchArchivo).
  FINALLY:
    DELETE OBJECT lobWrite NO-ERROR.
  END FINALLY.
END.

DISPLAY 'Generacin XML notas programas' WITH FRAME b.
DISPLAY '(destino vacio para saltear)' WITH FRAME b.
UPDATE lchArchivo WITH FRAME b.
IF lchArchivo NE ? AND lchArchivo NE '' THEN DO ON ERROR UNDO, THROW:
  /* verificar la conexin a la base de datos, si no hay conexin no hay nada que hacer */
  RUN connectDB("xrefsrc",'claves','chonik',2563).
  IF NOT CONNECTED('xrefsrc') THEN
    RETURN.
  lobWrite = NEW Notaswriter().
  lobWrite:clgFormatOutput = llgBonito.
  lobWrite:writeXML(lchArchivo).
  FINALLY:
    DELETE OBJECT lobWrite NO-ERROR.
  END FINALLY.
END.

/* la informacin de Alias y estructura de menes, se toma del 
mapa de sistema */
/*

/***
Alias generation requires an unavailable database.
--
La generacin de alias requiere de una base de datos que no se encuentra disponible.
****/

DISPLAY 'Generacin XML alias programas' WITH FRAME d.
DISPLAY '(destino vacio para saltear)' WITH FRAME d.
UPDATE lchArchivo WITH FRAME d.
IF lchArchivo NE ? AND lchArchivo NE '' THEN DO ON ERROR UNDO, THROW:
  /* verificar la conexin a la base de datos, si no hay conexin no hay nada que hacer */
  RUN connectDB("mapsissrc",'claves','chonik',2563).
  IF NOT CONNECTED('mapsissrc') THEN
    RETURN.
  DISPLAY 'Lista de rutas por mdulo' WITH FRAME d.
  UPDATE mchPaths WITH FRAME d.
  lobWrite = NEW Aliaswriter().
  CAST(lobWrite,Aliaswriter):cchModulePaths = mchPaths.
  lobWrite:clgFormatOutput = llgBonito.
  lobWrite:writeXML(lchArchivo).
  FINALLY:
    DELETE OBJECT lobWrite NO-ERROR.
  END FINALLY.
END.*/
